// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from clober_msgs:msg/ControllerState.idl
// generated code does not contain a copyright notice
#include "clober_msgs/msg/detail/controller_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `fault_flags`
#include "rosidl_runtime_c/string_functions.h"

bool
clober_msgs__msg__ControllerState__init(clober_msgs__msg__ControllerState * msg)
{
  if (!msg) {
    return false;
  }
  // battery_voltage
  // charging_voltage
  // current_12v
  // current_24v
  // temperature
  // fault_flags
  if (!rosidl_runtime_c__String__Sequence__init(&msg->fault_flags, 0)) {
    clober_msgs__msg__ControllerState__fini(msg);
    return false;
  }
  // emergency_stop
  return true;
}

void
clober_msgs__msg__ControllerState__fini(clober_msgs__msg__ControllerState * msg)
{
  if (!msg) {
    return;
  }
  // battery_voltage
  // charging_voltage
  // current_12v
  // current_24v
  // temperature
  // fault_flags
  rosidl_runtime_c__String__Sequence__fini(&msg->fault_flags);
  // emergency_stop
}

clober_msgs__msg__ControllerState *
clober_msgs__msg__ControllerState__create()
{
  clober_msgs__msg__ControllerState * msg = (clober_msgs__msg__ControllerState *)malloc(sizeof(clober_msgs__msg__ControllerState));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(clober_msgs__msg__ControllerState));
  bool success = clober_msgs__msg__ControllerState__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
clober_msgs__msg__ControllerState__destroy(clober_msgs__msg__ControllerState * msg)
{
  if (msg) {
    clober_msgs__msg__ControllerState__fini(msg);
  }
  free(msg);
}


bool
clober_msgs__msg__ControllerState__Sequence__init(clober_msgs__msg__ControllerState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  clober_msgs__msg__ControllerState * data = NULL;
  if (size) {
    data = (clober_msgs__msg__ControllerState *)calloc(size, sizeof(clober_msgs__msg__ControllerState));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = clober_msgs__msg__ControllerState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        clober_msgs__msg__ControllerState__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
clober_msgs__msg__ControllerState__Sequence__fini(clober_msgs__msg__ControllerState__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      clober_msgs__msg__ControllerState__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

clober_msgs__msg__ControllerState__Sequence *
clober_msgs__msg__ControllerState__Sequence__create(size_t size)
{
  clober_msgs__msg__ControllerState__Sequence * array = (clober_msgs__msg__ControllerState__Sequence *)malloc(sizeof(clober_msgs__msg__ControllerState__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = clober_msgs__msg__ControllerState__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
clober_msgs__msg__ControllerState__Sequence__destroy(clober_msgs__msg__ControllerState__Sequence * array)
{
  if (array) {
    clober_msgs__msg__ControllerState__Sequence__fini(array);
  }
  free(array);
}
