// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from clober_msgs:msg/Feedback.idl
// generated code does not contain a copyright notice
#include "clober_msgs/msg/detail/feedback__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `controller_state`
#include "clober_msgs/msg/detail/controller_state__functions.h"
// Member `left_motor`
// Member `right_motor`
#include "clober_msgs/msg/detail/motor_state__functions.h"

bool
clober_msgs__msg__Feedback__init(clober_msgs__msg__Feedback * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    clober_msgs__msg__Feedback__fini(msg);
    return false;
  }
  // controller_state
  if (!clober_msgs__msg__ControllerState__init(&msg->controller_state)) {
    clober_msgs__msg__Feedback__fini(msg);
    return false;
  }
  // left_motor
  if (!clober_msgs__msg__MotorState__init(&msg->left_motor)) {
    clober_msgs__msg__Feedback__fini(msg);
    return false;
  }
  // right_motor
  if (!clober_msgs__msg__MotorState__init(&msg->right_motor)) {
    clober_msgs__msg__Feedback__fini(msg);
    return false;
  }
  return true;
}

void
clober_msgs__msg__Feedback__fini(clober_msgs__msg__Feedback * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // controller_state
  clober_msgs__msg__ControllerState__fini(&msg->controller_state);
  // left_motor
  clober_msgs__msg__MotorState__fini(&msg->left_motor);
  // right_motor
  clober_msgs__msg__MotorState__fini(&msg->right_motor);
}

clober_msgs__msg__Feedback *
clober_msgs__msg__Feedback__create()
{
  clober_msgs__msg__Feedback * msg = (clober_msgs__msg__Feedback *)malloc(sizeof(clober_msgs__msg__Feedback));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(clober_msgs__msg__Feedback));
  bool success = clober_msgs__msg__Feedback__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
clober_msgs__msg__Feedback__destroy(clober_msgs__msg__Feedback * msg)
{
  if (msg) {
    clober_msgs__msg__Feedback__fini(msg);
  }
  free(msg);
}


bool
clober_msgs__msg__Feedback__Sequence__init(clober_msgs__msg__Feedback__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  clober_msgs__msg__Feedback * data = NULL;
  if (size) {
    data = (clober_msgs__msg__Feedback *)calloc(size, sizeof(clober_msgs__msg__Feedback));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = clober_msgs__msg__Feedback__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        clober_msgs__msg__Feedback__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
clober_msgs__msg__Feedback__Sequence__fini(clober_msgs__msg__Feedback__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      clober_msgs__msg__Feedback__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

clober_msgs__msg__Feedback__Sequence *
clober_msgs__msg__Feedback__Sequence__create(size_t size)
{
  clober_msgs__msg__Feedback__Sequence * array = (clober_msgs__msg__Feedback__Sequence *)malloc(sizeof(clober_msgs__msg__Feedback__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = clober_msgs__msg__Feedback__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
clober_msgs__msg__Feedback__Sequence__destroy(clober_msgs__msg__Feedback__Sequence * array)
{
  if (array) {
    clober_msgs__msg__Feedback__Sequence__fini(array);
  }
  free(array);
}
