// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from clober_msgs:msg/MotorState.idl
// generated code does not contain a copyright notice

#ifndef CLOBER_MSGS__MSG__DETAIL__MOTOR_STATE__FUNCTIONS_H_
#define CLOBER_MSGS__MSG__DETAIL__MOTOR_STATE__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "clober_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "clober_msgs/msg/detail/motor_state__struct.h"

/// Initialize msg/MotorState message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * clober_msgs__msg__MotorState
 * )) before or use
 * clober_msgs__msg__MotorState__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_clober_msgs
bool
clober_msgs__msg__MotorState__init(clober_msgs__msg__MotorState * msg);

/// Finalize msg/MotorState message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_clober_msgs
void
clober_msgs__msg__MotorState__fini(clober_msgs__msg__MotorState * msg);

/// Create msg/MotorState message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * clober_msgs__msg__MotorState__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_clober_msgs
clober_msgs__msg__MotorState *
clober_msgs__msg__MotorState__create();

/// Destroy msg/MotorState message.
/**
 * It calls
 * clober_msgs__msg__MotorState__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_clober_msgs
void
clober_msgs__msg__MotorState__destroy(clober_msgs__msg__MotorState * msg);


/// Initialize array of msg/MotorState messages.
/**
 * It allocates the memory for the number of elements and calls
 * clober_msgs__msg__MotorState__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_clober_msgs
bool
clober_msgs__msg__MotorState__Sequence__init(clober_msgs__msg__MotorState__Sequence * array, size_t size);

/// Finalize array of msg/MotorState messages.
/**
 * It calls
 * clober_msgs__msg__MotorState__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_clober_msgs
void
clober_msgs__msg__MotorState__Sequence__fini(clober_msgs__msg__MotorState__Sequence * array);

/// Create array of msg/MotorState messages.
/**
 * It allocates the memory for the array and calls
 * clober_msgs__msg__MotorState__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_clober_msgs
clober_msgs__msg__MotorState__Sequence *
clober_msgs__msg__MotorState__Sequence__create(size_t size);

/// Destroy array of msg/MotorState messages.
/**
 * It calls
 * clober_msgs__msg__MotorState__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_clober_msgs
void
clober_msgs__msg__MotorState__Sequence__destroy(clober_msgs__msg__MotorState__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // CLOBER_MSGS__MSG__DETAIL__MOTOR_STATE__FUNCTIONS_H_
